This file will contain the basic definition of the scoreboard and its 
   common methods such as add_to_sb() and check_from_sb()
<'
package sbt;

import sbt_test_writing/e/sbt_packet;

//Currently, the scoreboard has very limited functionality. Objects in the 
//environment interact with the scoreboard via the add_to_sb() and check_from_sb()
//methods.  At the end of a simulation, a number of automated checks are performed
//to ensure that all packets sent into the DUT were received correctly.
unit sbt_scoreboard_u {

   //This uint will uniquely tag all scoreboards  
   scoreboard_id: uint;
   keep soft scoreboard_id == 0;
 
   //These two lists will implement very basic data checking
   //generated list is used to store items that have been generated
   !generated_list: list of sbt_packet_s;
   !received_list: list of sbt_packet_s;

   //this method will take in a packet and add it to the appropriate
   add_to_sb(packet_to_add: sbt_packet_s) is {
      generated_list.add(packet_to_add);
   }; // add_to_sb(packe...
   
   
   //this method will take in a packet and search through the list
   //of expected outputs to try and find an exact match.  If a match is 
   //found, then the item is deleted from the expected output list
   check_from_sb(packet_to_check: sbt_packet_s) is {
      received_list.add(packet_to_check);
   }; // check_from_sb(p...

   
   //extend the built-in check() method (called automatically at the 
   //end of every simulation run) to perform some standard checks such 
   //as ensuring that all items have been deleted from the expected output
   //list.
   check() is also {
      var diffs: list of string;

      check that generated_list.size() == received_list.size() else 
      dut_error(vt.text_style(RED,"Generated and Received packet lists DO NOT MATCH in Size "));
'>      
      //check all packets in the list...eventually this code should be moved to the 
      //check_from_sb() method to perform on-th-fly checking
      for each (generated_packet) in generated_list {
         diffs = deep_compare_physical(generated_packet, received_list[index], 10);
         if diffs.size() != 0 {
            out(diffs);
            diffs.clear();
         }; // if diffs.size()...
      }; // for each (gener...
<'        
   }; // check() is also...

 }; //

'>
