This unit will describe an SBT agent.  This agent will contain a 
   sequence driver, a BFM and a monitor
   
<'
package sbt;

import sbt_bfm;
import sbt_monitor;

//The TX agent houses instantiations for the BFM and the Monitor
unit sbt_tx_agent_u {

   //This field can be used to uniquely identify all agents within
   //a list.  When running on devices with multiple channels, this 
   //field should note the channel number
   agent_id: uint;
   keep soft agent_id == UNDEF;

   //The agent can be placed in either ACTIVE or PASSIVE 
   //mode using the built-in predefined enumerated erm_active_passive
   //type
   active_passive: erm_active_passive_t;

   //The clocking event will be pushed into the agent 
   //by the environment
   event clock_e;
   
   when ACTIVE'active_passive sbt_tx_agent_u {
      //instantiate a list of bfm's
      bfm: sbt_bfm_u is instance;
   
      //push the bfm_id into the bfm
      keep bfm.bfm_id == agent_id;
      
      //whenever the agents clock is emitted
      //emit all of the clocks in the BFM's to 
      //keep them synchronized
      on clock_e {
         emit bfm.clock_e;
      }; // on clock_e
   }; // when ACTIVE'erm...

   //instantiate a monitor in the agent
   monitor: sbt_monitor_u is instance;
   keep monitor.monitor_id == agent_id;

   on clock_e {
      emit monitor.clock_e;
   }; // unit sbt_ag...

   
 }; //

'>
