<'
import sbt_test_writing/examples/sbt_test_writing_config;

extend sbt_env_u {
   //connect the clock to the verilog input_clock signal
   event clock_e is only @sys.any;
}; // extend sbt_env_...


extend sbt_bfm_u {
   drive(packet_to_drive: sbt_packet_s)@clock_e is only {
      
      //store the packet in a temporary location 
      //for the environment to use
      current_packet = packet_to_drive;
      
      //pack the higher level data structure into a list of bits 
      //for a complete explanation of the pack method, refer to the 
      //online specman docs
      var packed_packet: list of byte = pack(packing.low, packet_to_drive);
      
      //drive each bit out onto the data signal one bit at a time, on every 
      //clock edge
      for each in packed_packet do {
         
         //hook method
         just_before_driving();
         
         //hook method
         just_after_driving();
         
         wait cycle;
      }; // for each in pac...
      
      //wait for a delay before next packet is accepted
      wait [packet_to_drive.packet_delay]*cycle;

   }; // drive(packet_to...
}; // extend sbt_bfm_...

extend sbt_monitor_u {
   event fp_rise is only @sys.any;
   
   receive_data(): sbt_packet_s @clock_e is only {
      
      var data_collected: list of byte;

      just_before_receiving();

      //loop forever
      while TRUE {
         wait cycle;
      }; // while TRUE

      //call to a hook method
      just_after_receiving();
      
   };

}; // extend sbt_moni...

extend sbt_reset_agent_u {
   
   reset()@clock_e is only {
      
      //generate a new random number of clocks to hold the 
      //reset pin for.  This ensures that, if reset is ever 
      //called during a simulation, a different number of 
      //clocks will occur
      gen number_of_clocks;
      
      //wait for a random number of clocks
      wait [number_of_clocks] * cycle;
      
      //emit the reset_done event to let the environment 
      //know that the reset is complete
      emit reset_done;
      
   }; // reset()@clock_e...
}; // extend sbt_rese...

'>
